# Entity Visibility Preview

## Introduction

This module provides a new field type: entity visibility condition.

This new field allows to control the access to content entities (view
operation not on admin routes). A plugin system allows to add new condition
type.

Warning! The module implements hook_entity_access() so the access is checked
only when this hook is triggered, for example on the page of a node. So if the
content is displayed using a view for example, there is no access check.

A generic implementation of node_access hooks can't be done (if you have an idea
on how to do a generic implementation open an issue and provide a patch ;)).

For now, you are able to:
* Add a new field type entity_visibility_preview
* Configure the field with selected plugins
* Global configuration form
* Preview the website depending on conditions

### Entity Visibility Preview Simple Grants submodule

The entity_visibility_preview_simple_grants submodule integrates the
entity_visibility_preview module with grant api.

Using the submodule will allow node lists (entity query, views, search_api)
to check permissions of current user according to taxonomies / current date.

The module works using the "preview" form of the entity_visibility_preview
module.

Warning! The entity_visibility_preview_simple_grants submodule only connects
the taxonomy_condition and date_range_condition plugins with the grant api.
Any other access plugin must be handled manually.

## Requirements

Each condition plugin can require different modules, if the requirements are not
satisfied the plugin doesn't show up in the field settings.

The Taxonomy condition plugin needs the following modules:
* Taxonomy (Core)

The Date range condition plugin needs the following modules:
* Datetime (core)

## Installation

Install and enable this module like any other Drupal module.

## Configuration

* Enable the Entity Visibility Preview module on your site.
* Add an entity visibility preview field to an entity type.
* Select the required visibility condition plugins on this field instance.
* Configure if needed the plugins in the field settings.
* Go to one content entity edit form where the field is added and
  configure visibility for this content.
* Go to the configuration page
  (`/admin/config/content/entity_visibility_preview/settings`) and choose your
  module settings.
* If you use the Taxonomy condition plugin, you can go to a specific
  configuration page
  (`/admin/config/content/entity_visibility_preview/taxonomy_condition`) and
  choose your anonymous settings for each field on each entity type.
* View your entity with the specific condition you just configured.

## Credits

SVG icon eye.svg taken from https://www.iconfinder.com/icons/1608688/eye_icon
and then modified.

## Maintainers

Current maintainers:
* [Camille Liccia (Piegefull)](https://www.drupal.org/user/3526109)
* [Florent Torregrosa (Grimreaper)](https://www.drupal.org/user/2388214)
* [Bastien Rigon (barig)](https://www.drupal.org/user/2537604)

This project has been sponsored by:
* [Smile](https://www.smile.eu): Sponsored initial development, evolutions,
  maintenance and support.
